<template>
  <div>Filter: <input v-model="filter"/></div>
</template>

<script>
export default {
  name: "Filter",

  props: {
    tickersList: {
      type: Array,
      required: true
    },
    filterInitialState: String
  },

  emits: ["filterUpdated"],

  data() {
    return {
      filter: this.filterInitialState
    }
  },

  methods: {
    doFilter() {
      const filterState = {
        filter: this.filter,
        filteredTickers: this.tickersList.filter(ticker => ticker.name.toLowerCase().includes(this.filter))
      }
      this.$emit("filterUpdated", filterState);
    }
  },

  watch: {
    filter() {
      this.doFilter();
    },
    tickersList() {
      this.doFilter();
    }
  },

  mounted() {
    this.doFilter();
  }
}
</script>